Bug 1295040 - Review Request: nodejs-mock-fs - A configurable mock file system
Review Request: nodejs-mock-fs - A configurable mock file system
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Parag AN(पराग)
Fedora Extras Quality Assurance
:
Depends On: 1295037
Blocks: nodejs-reviews
  Show dependency treegraph
 
Reported: 2016-01-01 04:16 EST by Tom Hughes
Modified: 2016-01-15 10:37 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-15 10:37:25 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
panemade: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Tom Hughes 2016-01-01 04:16:06 EST
Spec URL: http://tomh.fedorapeople.org//nodejs-mock-fs.spec
SRPM URL: http://tomh.fedorapeople.org//nodejs-mock-fs-3.6.0-1.fc23.src.rpm

Description:
The mock-fs module allows Node's built-in fs module to be backed
temporarily by an in-memory, mock file system. This lets you run
tests against a set of mock files and directories instead of lugging
around a bunch of test fixtures.
Comment 1 Parag AN(पराग) 2016-01-08 00:15:20 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines

==> This will be fixed with nodejs-rewire is included in Fedora.

- I am not sure if we can consider node/fs*.js as bundled libraries. Are they?
  
===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 40 files have
     unknown license. Detailed output of licensecheck in
     /home/parag/1295040-nodejs-mock-fs/licensecheck.txt
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.14 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.14
INFO: Mock Version: 1.2.14
Finish: chroot init
INFO: installing package(s): /home/parag/1295040-nodejs-mock-fs/results/nodejs-mock-fs-3.6.0-1.fc24.noarch.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 --setopt=deltarpm=false install /home/parag/1295040-nodejs-mock-fs/results/nodejs-mock-fs-3.6.0-1.fc24.noarch.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: nodejs-mock-fs-3.6.0-1.fc24.noarch.rpm
          nodejs-mock-fs-3.6.0-1.fc24.src.rpm
nodejs-mock-fs.noarch: W: only-non-binary-in-usr-lib
nodejs-mock-fs.noarch: W: dangling-symlink /usr/lib/node_modules/mock-fs/node_modules/rewire /usr/lib/node_modules/rewire
nodejs-mock-fs.noarch: W: dangling-symlink /usr/lib/node_modules/mock-fs/node_modules/semver /usr/lib/node_modules/semver
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Requires
--------
nodejs-mock-fs (rpmlib, GLIBC filtered):
    nodejs(engine)
    npm(rewire)
    npm(semver)



Provides
--------
nodejs-mock-fs:
    nodejs-mock-fs
    npm(mock-fs)



Source checksums
----------------
https://registry.npmjs.org/mock-fs/-/mock-fs-3.6.0.tgz :
  CHECKSUM(SHA256) this package     : 3fed50d70f8f91825b8fa19876a4a7990620ed232ccc970378011942ac1df4c6
  CHECKSUM(SHA256) upstream package : 3fed50d70f8f91825b8fa19876a4a7990620ed232ccc970378011942ac1df4c6


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Comment 2 Tom Hughes 2016-01-08 07:32:43 EST
Yes you're quite right that those bits of code are extract from various versions of node. They appear to be pretty much entirely unchanged once you figure out what exact git revision they were taken from...

It's because the builtin fs can't be mocked using rewire because it doesn't exist as a real file on disk but is builtin to Node instead, so rewire can't load it as source.

I can add "Requires: bundled(nodejs)" if you want - see https://bugzilla.redhat.com/show_bug.cgi?id=1291933 for a recent discussion about a similar problem.
Comment 3 Tom Hughes 2016-01-14 18:59:42 EST
Did you want me to add the bundled(nodejs) require to this?
Comment 4 Parag AN(पराग) 2016-01-14 21:25:35 EST
I think it will be good to add "bundled(nodejs)". Rest look fine.

APPROVED.
Comment 5 Tom Hughes 2016-01-15 02:05:08 EST
Thanks. I'll make that change.
Comment 6 Gwyn Ciesla 2016-01-15 09:28:16 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/nodejs-mock-fs

Note You need to log in before you can comment on or make changes to this bug.